/*-
 * ~~~~~~licensing~~~~~~
 * entaxy-management-plugin
 * ==========
 * Copyright (C) 2020 - 2021 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.ui.hawtio.h2;

import javax.servlet.ServletContext;
import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import io.hawt.web.plugin.HawtioPlugin;

public class PluginContextListener implements ServletContextListener {

   private static final Logger log = LoggerFactory.getLogger(PluginContextListener.class);

   HawtioPlugin plugin = null;
	
	
	@Override
	public void contextInitialized(ServletContextEvent sce) {
	      ServletContext context = sce.getServletContext();

	      plugin = new HawtioPlugin();
	      plugin.setContext(context.getContextPath());
	      plugin.setName(context.getInitParameter("plugin-name"));
	      plugin.setScripts(context.getInitParameter("plugin-scripts"));
	      plugin.setDomain(null);

	      try {
	         plugin.init();
	      } catch (Exception e) {
	         throw createServletException(e);
	      }

	      log.info("Initialized {} plugin", plugin.getName());
	}

	@Override
	public void contextDestroyed(ServletContextEvent sce) {
	      try {
	          plugin.destroy();
	       } catch (Exception e) {
	          throw createServletException(e);
	       }

	       log.info("Destroyed {} plugin", plugin.getName());
	    }

    protected RuntimeException createServletException(Exception e) {
       return new RuntimeException(e);
    }

}
